<template>
    <div class="page-table scrollable only-y" id="affix-container">
        <div class>
            <h1>Roles</h1>
            <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->

            <el-breadcrumb separator="/">
                <el-breadcrumb-item :to="{ path: '/' }">
                    <i class="mdi mdi-home-outline"></i>
                </el-breadcrumb-item>
                <el-breadcrumb-item>Roles</el-breadcrumb-item>

            </el-breadcrumb>

            <div style="text-align: right; position: relative">
                <el-button type="primary"
                           style="position: absolute; top: -30px; right: 0"
                           class=""
                           @click="onAdd">
                    <i class="mdi mdi-plus"> </i>
                    <span> Add</span>
                </el-button>
            </div>

        </div>
        <br/>
        <el-card class="box-card" style="text-align: left; margin: 20px 0" v-loading="loading">
            <div class="card-header">
            </div>
            <el-table id="style-3" rowClassName="pointer-row" @row-click="showDetail" :data="list">
                <el-table-column fixed prop="id" label="ID" width="100"></el-table-column>

                <el-table-column min-width="250" prop="name" label=" Name"></el-table-column>
                <el-table-column min-width="250" prop="description" label="Description"></el-table-column>
                <el-table-column min-width="250" prop="created_at" label="Created At"></el-table-column>

            </el-table>
            <!-- <div class="flex justify-space-between" style="align-items:center;">
            <span>Total items: {{total}}</span>
            </div> -->
        </el-card>
    </div>
</template>

<script>
    import {role as roleApi} from "~/services/apis/index";

    export default {
        name: "Role",
        data() {
            return {
                list: [],
                imageUrl: null,
                pageWidth: 0,
                userdata: {},
                loading: true,
                prop: "",
                dialogFormvisible: false,
            };
        },
        watch: {
            onSubmit() {
                this.onSearch();
            },
            "$route.query"() {
                this.getListData();
            }
        },
        methods: {
            openDialog(data) {
                this.userdata = data;
                this.dialogFormvisible = true;
            },
            __resizeHanlder: _.throttle(function (e) {
                //this.setPageWidth()
            }, 700),
            getListData() {
                this.loading = true;
                roleApi
                    .getRoles()
                    .then(res => {
                        this.list = res.data.data;
                        this.loading = false;
                        this.total = parseInt(res.headers["x-total-count"]);
                    });
            },
            showDetail(row) {
                var selection = window.getSelection();
                if (selection.toString().length !== 0) return;
                var id = row.id;
                this.$router.push({name: "role_edit", params: {id}});
            },

            onEdit(id, event) {
                event.preventDefault();
                event.stopPropagation();
                this.$router.push({path: `/roles/${id}/edit`});
            },
            onAdd(event) {
                 event.preventDefault();
                event.stopPropagation();
                this.$router.push({path: `/roles/add`});
            }


        },
        mounted() {
            this.getListData();
        }
    };
</script>

<style lang="scss" scoped>
    @import "../../../assets/scss/_variables";
    .z-index-999 {
        z-index:999;
    }
    .btn-eye {
        padding: 1px 6px;
    }
    .btn-action {
        padding: 6px;
        margin-right: 10px;
    }
    .btn-blue {
        width: 120px;
        color: rgb(95, 143, 223);
    }
    .btn-red {
        color: red;
    }
    // .el-table thead {
    //     color: #666 !important;
    // }
</style>

